<?php
// Session wird bentigt, damit der Adminbereich funktioniert!!
session_start();

// Engindung der Config.php
require_once ('gaestebuch/config.php');

//Admin sperre, ab 3 Fehleingaben
if ($_SESSION['gaestebuch_admin_fehleingabe'] >= 1) {
	setcookie("gaestebuch", $_SESSION['gaestebuch_admin_fehleingabe'], time() + 43200, "/");
}
// Kleine Sperre, damit man nicht spamen kann (Zeitfaktor in der Config einstellen)
if ($SESSION['gaestebuch_spam_sperre'] == TRUE) {
    setcookie("spam_sperre", $_SESSION['gaestebuch_spam_sperre'], time() + $post_time, "/");
}

?>
<script type="text/javascript" src="<?php echo $file; ?>gaestebuch/funktionen.js"></script>
<?php
#############################################
#                                           #
#   ~~Gstebuch                             #
#			Version: 3.1~~      #
#                                           #
#	Um das Gstebuch einbinden und      #
#	anpassen zu knnen, lesen Sie       #
#	bitte die Beschreibung!             #
#                                           #
#############################################

/* 
~~~~~~~~~~~~~~~ Changelog ~~~~~~~~~~~~~~~
Created by Dennis & Philipp Schweinbenz
--> www.suchdichsatt.de

# Version 1.0 - fertiggestellt am 20.09.2010:
- Adminbereich: Eintrge lschen / Ip des Benutzers ansehen
- Neues Design
- Rechencaptcha und Zahlencaptcha
- Email Benachrichtigung

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Version 2.0 - fertiggestellt am 15.10.2010:
- Adminbereich: Eintrge ndern
- Neues Design des Admins (Farbe des Namens)
- Neuer Bbccode: Smilies, Nachrichten fett, kursiv oder unterstrichen markieren
- XHTML ready
- Spamabfang ber ein unsichtbares Input Feld
- Nachrichtenzhler (#1 #2 ...)

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Version 3.0 - fertiggestellt am 05.11.2010:
- Linksperre gefixed und ausgebaut
- Keine Ip Sperre mehr fr Admins
- bessere Ip Sperre durch Cookies & Sessions
- Badword Filter
- neues, normales Captcha
- neues Rechencaptcha
- Versionskontrolle, automatische Erkennung bei alter Version

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Version 3.1 - fertiggestellt am 24.11.2010:
- kleine nderung beim Badwort Filter
- besseren Bbccode (man kann jetzt auch Links eingeben)
- geschtzter Adminbereich (3 Fehlversuche = Sperre durch Session und Cookie)
- Fehlermeldung kann nun selbst erstellt werden (config.php)

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# In Planung
# Version 4.0
- Vorschlge, die eventuell noch von euch kommen werden

~~~~~~~~~~~~~~~ Changelog ~~~~~~~~~~~~~~~
*/

#####################################################
#                                                   #
#	~~Um das Gstebuch anpassen zu knnen,      #
#		ffnen Sie bitte die config.php     #
#		im gaestebuch Ordner! ~~            #
#                                                   #
#	~~ Restlichen Variablen definieren          #
#		Sollte man nicht ndern~~           #
#                                                   #
#####################################################

define('SELF', $_SERVER['PHP_SELF']); // SELF festlegen
define('FUNC', isset($_GET['func']) ? $_GET['func'] : NULL);
define('GB_FILE', $gb_path);
define('DATE_FORMAT', $date_format);

$url_benachrichtigung = $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; //Ermittlung der URL - Addresse

//Wochentage definieren
$wochentag = array("Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag");
$tagzahl = date("w"); // Tag ermitteln
$tag = $wochentag[$tagzahl]; //Wochentag ermitteln

// Rechen Code erzeugen
$eingabe_rechen = $_POST['eingabe_rechen']; // Eingabe des Users
$captcha_eingabe = $_POST['captcha_eingabe']; // Eingabe des Users
$zusatzfeld = $_POST['zusatzfeld']; // Gegen Spam - Eintrag hier = Spam

$gaestebuch_version = '3.1'; //Damit Sie eine Nachricht erhalten, wenn es eine neuere Version gibt!

#############################################
#                                           #
#	~~ Passwort:                        #
#			berprfung ~~      #
#                                           #
#############################################

if (FUNC == 'logout') {
	echo '<p>Sie haben sich ausgeloggt!</p>'; //Logout funktion
	unset($_SESSION['logedin']);
}

ob_end_flush();

echo '<p class="style">
<a href="' . SELF . '?func=&amp;#gaestebuch" id="gaestebuch">Kommentare anzeigen</a> - 
<a href="' . SELF . '?func=nachricht&amp;#gaestebuch">Nachricht erstellen</a> - 
<a href="' . SELF . '?func=admin&amp;#gaestebuch">Adminbereich</a>'; //Men Anzeige - Nachricht erstellen/ansehen
//Wenn der Admin eingelogt ist, den auslog Link ausgeben
if (!empty($_SESSION['logedin'])) echo ' - <a href="' . SELF . '?func=logout&amp;#gaestebuch">Ausloggen</a><br />'; 
echo '</p>';

switch (FUNC)
{

    #####################################
    #					#
    #	~~ default:                     #
    #		Nachricht anzeigen ~~   #
    #                                   #
    #####################################
    default:

    if (!$fp = @fopen(GB_FILE, 'r')) { //ffnen des Textfeldes/Datenbank
        echo $datenbank_fehler_nachricht;
        break;
    }

    $i = 0;
    $data = NULL;

    while (!feof($fp)) {
        $i++;
        $data = fgets($fp, 4096);
        if (empty($data)) break;
        list ($datum, $tag, $zaehler, $absender, $name, $nachricht, $ip) = str_replace('\|', '|', preg_split('/(?<!\\\)(\|)/', $data));
	//Daten auslesen und in Variablen packen
			
	if ($smilies == 1) {
            // Smilie funktion
            $search  = array(
                            ':D',
                            '^^',
                            ':P',
                            ':o',
                            ':-/',
                            ';(',
                            ':(',
                            '-.-'
                            );

            $replace = array(
                            '<img src="http://suchdichsatt.de/bilder/smilies/cool.png" style="width: 25px; height: 25px;" alt=":D" />',
                            '<img src="http://suchdichsatt.de/bilder/smilies/smile.png" style="width: 25px; height: 25px;" alt="^^" />',
                            '<img src="http://suchdichsatt.de/bilder/smilies/baeh.png" style="width: 25px; height: 25px;" alt=":P" />',
                            '<img src="http://suchdichsatt.de/bilder/smilies/erstaunt.png" style="width: 25px; height: 25px;" alt=":o" />',
                            '<img src="http://suchdichsatt.de/bilder/smilies/normal.png" style="width: 25px; height: 25px;" alt=":-/" />',
                            '<img src="http://suchdichsatt.de/bilder/smilies/flame.png" style="width: 25px; height: 25px;" alt=";(" />',
                            '<img src="http://suchdichsatt.de/bilder/smilies/traurig.png" style="width: 25px; height: 25px;" alt=":(" />',
                            '<img src="http://suchdichsatt.de/bilder/smilies/boese.png" style="width: 25px; height: 25px;" alt="-.-" />'
                            );

            $nachricht = str_replace($search, $replace, $nachricht);
            // Ende Smilie
	}
        $nachricht = preg_replace("/\[b\](.*)\[\/b\]/Usi", "<b>\\1</b>", $nachricht); //BBccode ersetzen in htmml tags
        $nachricht = preg_replace("/\[i\](.*)\[\/i\]/Usi", "<i>\\1</i>", $nachricht);
        $nachricht = preg_replace("/\[u\](.*)\[\/u\]/Usi", "<u>\\1</u>", $nachricht);
        $nachricht = preg_replace("/\[url=(.*)\](.*)\[\/url]/Usi", "<a href='\\1' alt='\\1' info='\\1' title='\\1' target='_blank'>\\2</a>", $nachricht);

	if ($absender == a) {
            echo ("\n <p style=\"color: " .$farbe. "; display: inline;\"> $name <span style=\"float: right; margin-right: 20px;\">#$zaehler</span> <br /></p>
            <p>($tag, " . date(DATE_FORMAT, $datum) . ")<br />$nachricht<br /><br /><img src=\"http://www.suchdichsatt.de/bilder/contentlinie.png\"
            class=\"trennlinie\" alt=\"Trennlinie\" /></p>");
	} elseif ($absender == b) {
            echo ("\n <p style=\"display: inline;\"><b>$name</b> <span style=\"float: right; margin-right: 20px;\">#$zaehler</span> <br /></p>
            <p>($tag, " . date(DATE_FORMAT, $datum) . ")<br />$nachricht<br /><br /><img src=\"http://www.suchdichsatt.de/bilder/contentlinie.png\"
            class=\"trennlinie\" alt=\"Trennlinie\" /></p>");
	}
    }
    fclose($fp); //Datenbank schlieen
									
    break;

    #####################################
    #					#
    #	~~ nachricht:    		#
    #		Nachricht erstellen ~~  #
    #                                   #
    #####################################

    case 'nachricht':

    $name = $_POST['name']; //Eingabe des Users in eine Variable speichern
    $nachricht = $_POST['nachricht'];

    if (isset($_POST['submit'])) { //berprfen, wenn submit Button gedrckt wird
        $now = time();
        $fehler = NULL;

        $name_len = strlen($name); // Buchstaben des Namens, wo eingegeben wurde
        $nachricht_len = strlen($nachricht); // Buchstaben der Nacxhricht, die eingegeben wurde

        if ($name) { //Name berprfen
            if ($name_len > $max_length) { //Nachricht grer als Max.
                $fehler.= '-Ihr Name ist zu lang, es sind ' . $name_len . ' Buchstaben, <br />
                aber nur Max. ' . $max_length . ' erlaubt.<br />'; // Error Message
            } elseif ($name_len < $min_length) {
                $fehler.= '-Ihr Name ist zu kurz!!  (Min: ' . $min_length . ') Buchstaben<br />'; //Nachricht kleiner als Minimum
            }
        } else { // Also wenn Name = leer
            $fehler.= '-Bitte geben Sie einen Namen ein!!<br />'; //Keine Nachricht vorhanden
        }

        if ($nachricht) {
            if ($nachricht_len > $max_nachricht) { //Nachricht grer als Max.
                $fehler.= '-Ihre Nachricht ist zu lang, es sind ' . $nachricht_len . ' Buchstaben, <br />
                            aber nur Max. ' . $max_nachricht . ' erlaubt.<br />';
            // Wenn mehr Links als erlaubt, dann ...
            } elseif (substr_count($nachricht, 'http://') + substr_count($nachricht, 'url') + substr_count($nachricht, 'href') > $maximal) {
                $fehler.= '-Es sind nur max. ' . $maximal . ' Links pro Beitrag erlaubt.<br />'; // Fehlermeldung ausgeben.
            } elseif ($nachricht_len < $min_nachricht) { // Betreff kleiner als Minimum
                $fehler.= '-Ihre Nachricht ist zu kurz!!  (Min: ' . $min_nachricht . ') Buchstaben<br />';  // Error Message
            }
        } else { //Wenn Betreff = leer
            $fehler.= '-Bitte geben Sie eine Nachricht ein!!<br />';  // Error Message
        }

        if ($captcha == 1) {
            if ($captcha_eingabe) { // berprfung des Captchas-Code
                if ($captcha_eingabe != $_SESSION['captcha_code']) {
                    $fehler.= '-Bitte geben Sie den richtigen Captcha-Code ein!<br />';  // Error Message
                }
            } else { // Wenn Captcha Code nicht gesetzt ist
                $fehler.= '-Bitte f&uuml;llen Sie das Feld mit dem Code aus!<br />'; // Error Message
            }
        }

        if ($rechen_captcha == 1) {
            if ($eingabe_rechen) { // Rechen-Code eingabe des Benutzers
                if ($eingabe_rechen != $_SESSION['rechen_captcha_code']) { // Eingabe des Users ungleich mit der Antwort
                    $fehler.= '-Bitte geben Sie das richtige Rechenergebnis ein!<br />'; // Error Message
                }
            } else { // Erste if Abfrage, Feld leer?
                $fehler.= '-Bitte f&uuml;llen Sie das Feld mit dem Rechen-Code aus!<br />'; // Error Message
            }
        }

        if ($zusatzfeld != "") { //Wenn das Feld nicht leer ist --> Spambot, fr User nicht unsichtbar!
            $fehler.= '-Spam Bot identifiziert!';
        } // Prft ob der Spambot das Feld ausfllt, wenn ja --> Spam

        if (!$fp = @fopen(GB_FILE, 'r')) { //ffnen der Datenbank
            echo 'Fehler beim &ouml;ffnen der Dateknbank, bitte versuchen Sie es sp&auml;ter noch einmal!';
            break;
        }

        list($datum, , , , , , $ip) = fgetcsv($fp, 4096, '|'); // Daten auslesen
        fclose($fp);

        //Zerstrung der Session + des Cookies wenn die Zeit abgelaufen ist
        if ($_SESSION['ip_spam_sperre'] == TRUE) {
            if ($now > $datum + $post_time) {
                unset($_SESSION['ip_spam_sperre']);
            }
        }

        //IP Adresse vergleichen | Sperre, wenn vorhanden
        if ($_SESSION['logedin'] == FALSE) {
            if ($_SESSION['gaestebuch_spam_sperre'] == TRUE or $_COOKIE["gaestebuch_spam_sperre"] == TRUE) {
                $fehler .= $ip_sperre_meldung; //IP Check
            }
        }

        if ($fehler) { // Ausgabe der error message
            echo '<p style="color: ' . $farbe . ';">' . $fehler . '</p>';
        } else {

        if ($badword_filter == 1) {
            foreach ($badwords as $badword) {
                $str = strlen($badword);
                $strb = $str - 2;
                $nachricht = eregi_replace($badword, substr($badword, 0, -$strb) . '**', $nachricht);
            }
        }

        $ip = $_SERVER['REMOTE_ADDR'];
        $_SESSION['gaestebuch_spam_sperre'] = $ip;
        

        if($_SESSION['logedin'] == TRUE) { // berprfen ob der Admin eingeloggt ist (mit sessions)
            $absender = 'a'; //Wenn ja Name beim Eintrag farbig schreiben
        } else {
            $absender = 'b';
        }

        $filesize = filesize(GB_FILE);
        $filesize = (empty($filesize)) ? 1024 : $filesize;

        if (!$fp = @fopen(GB_FILE, 'r+')) { //ffnen der Datenbank, bei Fehler...
            echo $datenbank_fehler_nachricht;
            break;
        }

        $data = fread($fp, $filesize);
        rewind($fp);

        $nachricht = htmlspecialchars($nachricht); // wandelt <, >, &, " in html Zeichen um ($lt; ... )

        if (!$fp = @fopen(GB_FILE, 'r')) { //ffnen der Datenbank
            echo $datenbank_fehler_nachricht;
            break;
        }

        list( , , $zaehler, , , , ) = fgetcsv($fp, 4096, '|'); //Zhler funktion
        $zaehler++;
        if ($zaehler == "") {
            $zaehler = 1;
        }

        $filesize = filesize(GB_FILE);
        $filesize = (empty($filesize)) ? 1024 : $filesize;
        if (!$fp = @fopen(GB_FILE, 'r+')) { //Datenbank ffnen
            echo $datenbank_fehler_nachricht;
            break;
        }
        $data = fread($fp, $filesize);
        rewind($fp);

        fwrite($fp, "$now|$tag|$zaehler|$absender|".str_replace("\n", NULL, str_replace('|', '\|', $name)).'|'.
        str_replace("\n", '<br />', $nachricht) . '|'.$_SERVER['REMOTE_ADDR'].'|'); //Speichern des Eintrags, in das Textfeld/Datenbank

        if ($benachrichtigung == 1) {
            mail ($ihre_adresse, 'Neuer Gb-eintrag', 'Jemand hat in Ihr Gaestebuch geschrieben!! Hier gehts zum Eintrag: http://' . $url_benachrichtigung);
        } // E-mail Benachrichtigung

        if (!empty($data)) fwrite($fp, "\n". $data);
        fclose($fp); // Schlieen der Datenbank
        echo '<p>Deine Nachricht wurde hinzugef&uuml;gt<br /><a href="' . SELF . '?func=&amp;#gaestebuch">Zur&uuml;ck zum G&auml;stebuch</a></p>';
        break; // Wenn die Nachricht versendet wurde, zu dieser Seite verlinken

        }
    } // Beendet die Abfrage am Anfang, ob Submit button gedrueckt wurde

    echo "\n".'
    <form method="post" name="formular" id="formular" action="' . SELF . '?func=nachricht&amp;#gaestebuch"><p>
    <label for="name">Name: *</label><br />
    <input type="text" name="name" value="' . $name . '" size="' . $size . '" /><br /><br />';

    echo '<label for="nachricht">Nachricht: *</label><br />';
    ?>
    <button type="button" onclick="insertText('[b]','[/b]')" title="[b][/b]"><b>b</b></button>
    <button type="button" onclick="insertText('[i]','[/i]')" title="[i][/i]"><i>i</i></button>
    <button type="button" onclick="insertText('[u]','[/u]')" title="[u][/u]"><u>u</u></button>
    <button type="button" onclick="insertURL()" title="[url][/url]">url</button>
    <?php
    if ($smilies == 1) {
    ?>
        <button type="button" onClick="window.open( '<?php echo $smilies_path; ?>' , 'smilies' , 'height=200,width=200' );">Smilies</button><br />
    <?php
    } else {
        echo '<br />';
    }

    echo '<textarea name="nachricht" id="nachricht" cols="' . $cols . '" rows="' . $rows . '">' . $nachricht . '</textarea><br />';

    if ($captcha == 1) {
        echo '<br /><br /><label for="captcha">Bitte geben Sie folgenden Captcha-Code ein: *</label><br />
        <img name="Sicherheitscode" src="' . $captcha_pfad . '" alt="Captcha" /><br /><br />
        <input type="text" name="captcha_eingabe" size="' . $size . '"><br />';
    }

    if ($rechen_captcha == 1) { //Rechencode erstellen
        echo '<br /><label for="rechencode">Bitte f&uuml;llen Sie das Rechen-Captcha aus! *</label><br />
        <img src="' . $rechen_captcha_pfad . '" alt="Rechencaptcha" /><br /><br />
        <input type="text" name="eingabe_rechen" size="' . $size . '" /><br />';
    }

    echo '
    <br />
    <input style="display: none;" type="text" size="10" value="" name="zusatzfeld" />
    <input type="submit" name="submit" value="Absenden" /><br />
    *-Pflichtfeld</p></form>'; //Formular erstellen

    break;

    #####################################
    #					#
    #	~~ admin:                       #
    #		Adminbereich ~~         #
    #                                   #
    #####################################
    case 'admin':

    if (isset($_POST['passwort'])) { //berprfung des Passworts
        $name = $_POST['name'];
        $passwort = md5($_POST['passwort']);

        if ($name == $a_name && $passwort == md5($a_passwort)) { //Wenn beide Eingaben stimmen -> Session starten
            $_SESSION['logedin'] = TRUE;
        }
    }
  
    if ($_SESSION['logedin'] != "") { //Wenn Session nicht leer ist...
        if ($_SESSION['logedin'] == TRUE) { //Wenn Session gesetzt dann...
            if (isset($_GET['d'])) { //Wenn lschen gedrckt wurde

                /*================================*\
                        -- admin delete --
                \*================================*/

                if (isset($_GET['c'])) {
                    if (!$fp = @fopen(GB_FILE, 'r')) { //ffnen der Datenbank
                        echo $datenbank_fehler_nachricht;
                        break;
                    }

                    $output = ''; //Output auf 0/leer setzen

                    while (!feof($fp)) {
                        $line = fgets($fp, 4096);

                        if (substr($line, 0, 10) == $_GET['d']) {
                            $output .= fread($fp, filesize(GB_FILE));
                            fclose($fp);

                            if (!$fp = @fopen(GB_FILE, 'w')) { //ffnen der Datenbank
                                echo $datenbank_fehler_nachricht;
                                break;
                            }

                        fwrite($fp, $output); //In die Datenbank schreiben | auf 0/leer setzen
                        fclose($fp);

                        //Ausgabe, wenn die Nachricht gelscht wurde
                        echo '<p>Die Nachricht wurde <b>gel&ouml;scht</b>.<br />
                        <a href="' . SELF . '?func=admin&amp;#gaestebuch">Hier gehts zur&uuml;ck</a><br /></p>';

                        break 2;
                        } else {
                            $output .= $line;
                        }
                    }

                    fclose($fp); // Schlieen der Datenbank

                    echo '<p>Fehler beim l&ouml;schen dieses Beitrags. Hier gehts zur&uuml;:
                    <a href="' . SELF . '?func=admin&amp;#gaestebuch">admin</a></p>';
                }

                if (!$fp = @fopen(GB_FILE, 'r')) { //ffnen der Datenbank
                    echo $datenbank_fehler_nachricht;
                    break;
                }

                while (!feof($fp)) {
                    $line = fgets($fp, 4906);
                
                    if (substr($line, 0, 10) == $_GET['d']) {
                        list($datum, $tag, $zaehler, $absender, $name, $nachricht, $ip) = explode ('|', $line); //GB_FILE auslesen
                        echo '<p>Sind sie sicher, dass sie diese Nachricht l&ouml;schen wollen?</p>'; //Nachricht lschen?
					
                        if ($absender == a) { //Darstellung im Adminbereich - Daten lschen
                            echo '<p style="color: ' .$farbe. '; display: inline;">' .$name . '
                            <span style="float: right; margin-right: 20px;">#' . $zaehler . '</span><br /></p>
                            <p>(' . $tag . ', ' . date(DATE_FORMAT, $datum) . ')<br />' . $nachricht . '</p>';
                        } elseif ($absender == b) {
                            echo '<p style="display: inline;"><b>' .$name . '</b>
                            <span style="float: right; margin-right: 20px;">#' . $zaehler . '</span><br /></p>
                            <p>(' . $tag . ', ' . date(DATE_FORMAT, $datum) . ')<br />' . $nachricht . '</p>';
                        }
					
                        echo '<p><a href="' . SELF . '?func=admin&amp;d='.$_GET['d'].'&amp;c=1&amp;#gaestebuch"><u>Ja</u></a> -
                        <a href="' . SELF . '?func=admin&amp;#gaestebuch">Nein</a></p>'; //Wenn Admin lschen gedrckt hat ...
                        break 2;
                    }
                }

                fclose($fp); //Schlieen der Datenbank
                echo '<p>Leider ist ein Fehler aufgetreten. Hier gehts zur&uuml;ck: <a href="' . SELF . '?func=admin&amp;#gaestebuch">admin</a></p>';
            }
		
            if (isset($_GET['e'])) {
                /*================================*\
                            -- admin edit --
		\*================================*/

		if (isset($_GET['c'])) {
                    $name = $_POST['name']; //Eingabe des Users in eine Variable speichern
                    $nachricht = $_POST['nachricht']; //Eingabe des Users in eine Variable speichern
                    $zaehler = $_POST['zaehler']; //Eingabe des Users in eine Variable speichern
                    $name_len = strlen($name); // Buchstaben des Namens, wo eingegeben wurde
                    $nachricht_len = strlen($nachricht); // Buchstaben der Nacxhricht, die eingegeben wurde
                    $fehler = NULL;

                    if ($name) {
                        if ($name_len > $max_length) { //Nachricht grer als Max.
                            $fehler.= '-Ihr Name ist zu lang, es sind ' . $name_len . ' Buchstaben, <br />
                            aber nur Max. ' . $max_length . ' erlaubt.<br />'; // Error Message
                        } elseif ($name_len < $min_length) {
                            $fehler.= '-Ihr Name ist zu kurz!!  (Min: ' . $min_length . ') Buchstaben<br />'; //Nachricht kleiner als Minimum
                        }
                    } else { // Also wenn Name = leer
                        $fehler.= '-Bitte geben Sie einen Namen ein!!<br />'; //Keine Nachricht vorhanden
                    }
	
                    if ($nachricht) {
                        if ($nachricht_len > $max_nachricht) { //Nachricht grer als Max.
                            $fehler.= '-Ihre Nachricht ist zu lang, es sind ' . $nachricht_len . ' Buchstaben, <br />
                            aber nur Max. ' . $max_nachricht . ' erlaubt.<br />';
                        }
                    }

                    if ($fehler) { // Ausgabe der error message
                        echo '<p style="color: ' . $farbe . ';">' . $fehler . '</p>';
                    } else {
                        if (!$fp = @fopen(GB_FILE, 'r')) {
                            echo $datenbank_fehler_nachricht;
                            break;
			}

			$output = '';
			while (!feof($fp)) {
                            $line = fgets($fp, 4096);
                            if (substr($line, 0, 10) == $_GET['e']) {
                                //Daten auslesen und in Variablen packen
                                list($datum, , , $absender, , , $ip) = str_replace('\|', '|', preg_split("/(?<!\\\)(\|)/", $line));

				// Anzeige/Ausgabe beim Eintrag ndern erzeugen
				$output .= $datum . '|' . $tag . '|' . $zaehler . '|' . $absender . '|'
				. str_replace("\n", NULL, str_replace('|', '\|', $name)).'|'
				. str_replace("\n", ' ', $nachricht). '|' . $ip . "|\n".fread($fp, filesize(GB_FILE));
                                fclose($fp);

                                $fp = @fopen(GB_FILE, 'w'); // In die Datenbank/ das Textdokument schreiben
				fwrite($fp, $output);
				fclose($fp);

				echo '<p>Die Nachricht wurde <b>ge&auml;ndert</b>.<br /><a href="' . SELF . '?func=admin&amp;#gaestebuch">
				Hier gehts zur&uuml;ck</a><br /></p>';

				break 2;
				} else {
                                    $output .= $line;
				}
                            }
                            fclose($fp);
                            echo '<p>Leider ist ein Fehler aufgetreten. Hier gehts zur&uuml;ck: <a href="' . SELF . '?func=admin&amp;#gaestebuch">admin</a></p>';
                        }
                    }

                    if (isset($_POST['submit'])) { // Nachricht ndern - Men
                        echo "\n".'
			<form method="post" name="formular" action="' . SELF . '?func=admin&amp;e='.$_GET['e'].'&amp;c=1&amp;#gaestebuch">
			<p><label for="name">Name:</label>
			<input type="text" name="name" value="' . $name . '" size="' . $size . '" /></p><br />
				
			<label for="nachricht">Nachricht: *</label><br />';
			?>
			<button type="button" onclick="insertText('[b]','[/b]')" title="[b][/b]"><b>b</b></button>
			<button type="button" onclick="insertText('[i]','[/i]')" title="[i][/i]"><i>i</i></button>
			<button type="button" onclick="insertText('[u]','[/u]')" title="[u][/u]"><u>u</u></button>
                        <button type="button" onclick="insertURL()" title="[url][/url]">url</button>
			<?php
                        if ($smilies == 1) {
                            ?>
                            <button type="button" onClick="window.open( '<?php echo $smilies_path; ?>' , 'smilies' , 'height=200,width=200' );">Smilies</button><br />
                            <?php
                        } else {
                            echo '<br />';
                        }
                        echo '<textarea name="nachricht" id="nachricht" cols="' . $cols . '" rows="' . $rows . '">' . $nachricht . '</textarea><br />
			<input type="submit" name="submit" value="&Auml;ndern" />
			</p></form>';
			break;
                    }


		if (!$fp = @fopen(GB_FILE, 'r')) {
                    echo $datenbank_fehler_nachricht;
                    break;
		}

		while (!feof($fp)) {
                    $line = fgets($fp, 4906);
                    if (substr($line, 0, 10) == $_GET['e']) {
                        list( , , $zaehler, , $name, $nachricht, ) = str_replace('\|', '|', preg_split("/(?<!\\\)(\|)/", $line));

			$nachricht = htmlspecialchars($nachricht); // wandelt <, >, &, " in html Zeichen um ($lt; ... )

			echo "\n".'
                        <form method="post" name="formular" action="' . SELF . '?func=admin&amp;e='.$_GET['e'].'&amp;c=1&amp;#gaestebuch"><p>
                        <label for="name">Name:</label><br />
                        <input type="text" name="name" value="' . $name . '" size="' . $size . '" />
                        <span style="float: right; margin-right: 20px;">#
                        <input type="text" name="zaehler" value="'   . $zaehler . '" size="1" /></span><br />

                        <label for="nachricht">Nachricht:</label><br />';
                        ?>
                        <button type="button" onclick="insertText('[b]','[/b]')" title="[b][/b]"><b>b</b></button>
                        <button type="button" onclick="insertText('[i]','[/i]')" title="[i][/i]"><i>i</i></button>
                        <button type="button" onclick="insertText('[u]','[/u]')" title="[u][/u]"><u>u</u></button>
                        <button type="button" onclick="insertURL()" title="[url][/url]">url</button>
                        <?php
                        if ($smilies == 1) {
                            ?>
                            <button type="button" onClick="window.open( '<?php echo $smilies_path; ?>' , 'smilies' , 'height=200,width=200' );">Smilies</button><br />
                            <?php
                        } else {
                            echo '<br />';
                        }
					
			echo '<textarea name="nachricht" id="nachricht" cols="' . $cols . '" rows="' . $rows . '">' . $nachricht . '</textarea><br />
			<input type="submit" name="submit" value="&Auml;ndern" /></p></form>';
                        break 2;
                    }
                }
                fclose($fp);
                echo '<p>Leider ist ein Fehler aufgetreten. Hier gehts zur&uuml;ck: <a href="' . SELF . '?func=admin&amp;#gaestebuch">admin</a></p>';
            }
            $gb_size = filesize(GB_FILE); // Wenn Admin eingelogt ist ...
            //Gre der Datenbank ausgeben
            echo '
            <p>~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~<br />
            File Size: '.round($gb_size / 1024, 1).'KB - Created by Dennis --&gt; <a href="http://suchdichsatt.de/" target="_blank">suchdichsatt</a><br />
            ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~<br />';
			
            $version_pruefung = fopen('http://www.suchdichsatt.de/scripte/gaestebuch/gaestebuch_version.txt', 'r');
            $data = fgets($version_pruefung, 4096);
            list ($aktuelle_version, $aktueller_name) = str_replace('\|', '|', preg_split("/(?<!\\\)(\|)/", $data));
            fclose($version_pruefung);

            if ($gaestebuch_version < $aktuelle_version) {
		echo '
		<img src="http://www.suchdichsatt.de/bilder/kreuz.png" alt="Kreuz" style="float: left; height: 25px; width: 25px; margin-top: 4px;" />
		Es ist eine neuere G&auml;stebuch Version Verf&uuml;gbar:<br />
		<a href="http://suchdichsatt.de/tutorials/php_gaestebuch.php" target="_blank">' . $aktueller_name . '</a>';
            } elseif ($gaestebuch_version == $aktuelle_version) {
		echo '
		<img src="http://www.suchdichsatt.de/bilder/haken.png" alt="Haken" style="float: left; height: 15px; width: 15px;" />
		Aktuelle Version';
            } else {
                echo 'Versionscheck nicht m&ouml;glich!';
            }
            echo '<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~<br /><br /></p>';
            if (!$fp = @fopen(GB_FILE, 'r')) { //ffnen der Datenbank
		echo $datenbank_fehler_nachricht;
		break;
            }

            $i = 0;
            $data = NULL;
            while (!feof($fp)) {
		$i++;
                $data = fgets($fp, 4096);
                if (empty($data)) break;
                // // Daten auslesen und in Variablen setzen
		list ($datum, $tag, $zaehler, $absender, $name, $nachricht, $ip) = str_replace('\|', '|', preg_split("/(?<!\\\)(\|)/", $data));

                if ($smilies == 1) {
                    // Smilie funktion
                    $search  = array(
                                    ':D',
                                    '^^',
                                    ':P',
                                    ':o',
                                    ':-/',
                                    ';(',
                                    ':(',
                                    '-.-'
                                    );
                 
                    $replace = array(
                                    '<img src="http://suchdichsatt.de/bilder/smilies/cool.png" style="width: 25px; height: 25px;" alt=":D" />',
                                    '<img src="http://suchdichsatt.de/bilder/smilies/smile.png" style="width: 25px; height: 25px;" alt="^^" />',
                                    '<img src="http://suchdichsatt.de/bilder/smilies/baeh.png" style="width: 25px; height: 25px;" alt=":P" />',
                                    '<img src="http://suchdichsatt.de/bilder/smilies/erstaunt.png" style="width: 25px; height: 25px;" alt=":o" />',
                                    '<img src="http://suchdichsatt.de/bilder/smilies/normal.png" style="width: 25px; height: 25px;" alt=":-/" />',
                                    '<img src="http://suchdichsatt.de/bilder/smilies/flame.png" style="width: 25px; height: 25px;" alt=";(" />',
                                    '<img src="http://suchdichsatt.de/bilder/smilies/traurig.png" style="width: 25px; height: 25px;" alt=":(" />',
                                    '<img src="http://suchdichsatt.de/bilder/smilies/boese.png" style="width: 25px; height: 25px;" alt="-.-" />'
                                    );

                    $nachricht = str_replace($search, $replace, $nachricht);
                    // Ende Smilie
                }

                $nachricht = preg_replace("/\[b\](.*)\[\/b\]/Usi", "<b>\\1</b>", $nachricht); //BBccode ersetzen in htmml tags
                $nachricht = preg_replace("/\[i\](.*)\[\/i\]/Usi", "<i>\\1</i>", $nachricht);
                $nachricht = preg_replace("/\[u\](.*)\[\/u\]/Usi", "<u>\\1</u>", $nachricht);
                $nachricht = preg_replace("/\[url=(.*)\](.*)\[\/url]/Usi", "<a href='\\1' alt='\\1' info='\\1' title='\\1' target='_blank'>\\2</a>", $nachricht);
					
		if ($absender == a) {
                    echo ("\n<p>
                    <a href=\"" . SELF . "?func=admin&amp;e=$datum&amp;#gaestebuch\">[&auml;ndern]</a>
                    <a href=\"" . SELF . "?func=admin&amp;d=$datum&amp;#gaestebuch\">[l&ouml;schen]</a>
                    <a href=\"http://whois.sc/$ip\">[IP ansehen]</a><br />"

                    . '<p style="color: ' .$farbe. '; display: inline;">' .$name . '
                    <span style="float: right; margin-right: 20px;">#' . $zaehler . '</span><br /></p>
                    <p>(' . $tag . ', ' . date(DATE_FORMAT, $datum) . ')<br />' . $nachricht . '<br />
                    <img src="http://www.suchdichsatt.de/bilder/contentlinie.png" class="trennlinie" alt="Trennlinie" /></p>');

                } elseif ($absender == b) {
                    echo ("\n<p>
                    <a href=\"" . SELF . "?func=admin&amp;e=$datum&amp;#gaestebuch\">[&auml;ndern]</a>
                    <a href=\"" . SELF . "?func=admin&amp;d=$datum&amp;#gaestebuch\">[l&ouml;schen]</a>
                    <a href=\"http://whois.sc/$ip\">[IP ansehen]</a><br />"

                    . '<p style="display: inline;"><b>' .$name . '</b>
                    <span style="float: right; margin-right: 20px;">#' . $zaehler . '</span><br /></p>
                    <p>(' . $tag . ', ' . date(DATE_FORMAT, $datum) . ')<br />' . $nachricht . '<br />
                    <img src="http://www.suchdichsatt.de/bilder/contentlinie.png" class="trennlinie" alt="Trennlinie" /></p>');
                }

                //Ausgabe, wenn Admin eingeloggt ist [lschen] und [ip ansehen] erzeugen
            }
            fclose($fp); // Datenbank schlieen
	} else { //Bei Fehler
            echo '<br />Sie sind nicht eingelogt<br />';
	}
    } else {
        if (isset($_POST['submit'])) {
            echo '<p>Falsches Passwort</p>'; // Eingabe falsch? | Admin Men - Passwort & Username
            $_SESSION['gaestebuch_admin_fehleingabe'] = $_SESSION['gaestebuch_admin_fehleingabe'] + 1;
        }
        if ($_SESSION['gaestebuch_admin_fehleingabe'] < 3 and empty($_COOKIE['gaestebuch'])) {
            echo "\n".'
            <form method="post" action="'.SELF.'?func=admin&amp;#gaestebuch"><p>

            <label for="name">Benutzername: </label><br />
            <input type="password" name="name" size="' . $size . '" /><br />

            <label for="passwort">Passwort: </label><br />
            <input type="password" name="passwort" size="' . $size . '" /><br />
            <input type="submit" name="submit" value="Absenden" /><br />
            </p></form>'; //Formulareingabe erzeugen
        } else {
            echo '<p>Sie haben 3 oder merhmals das falsche Passwort eingegeben, <br />
            leider m&uuml;ssen wir Sie aus Sicherheitsgr&uuml;nden f&uuml;r einige Zeit sperren!</p>';
        }

    }
    break;
}
#########################################
#					#
#       ~~ Created by Dennis    	#
#           --> www.suchdichsatt.de ~~ 	#
#                                       #
#########################################
?>