/* 
#########################################
#					#
#	~~Gstebuch			#
#		Version: 3.1~~          #
#					#
#	~~Funktionen fr den 		#
#		Bbccode erstellen~~	#
#					#
#########################################
*/


var idTextfeld = 'nachricht'; // ID der <textarea>
var rangeIE = null;

// IE/Gecko-Weiche zum Einfgen von Text ins Textfeld
function insertText(vor, nach) {
    var textfeld = document.getElementById(idTextfeld);
    textfeld.focus();  // falls Cursor auerhalb war

    if(typeof document.selection != 'undefined') { // fr IE, auch Opera
	insertIE(textfeld, vor, nach);
} else if (typeof textfeld.selectionStart != 'undefined') { // Geckos (FF)
        insertGecko(textfeld, vor, nach);
    }
}

function insertURL() {
    var textfeld = document.getElementById(idTextfeld);
    textfeld.focus();

    var url = prompt("Geben Sie die URL ein (mit http://)", '');
    var name = prompt("Geben Sie den Anzeigetext ein", '');
    if(url == null) url = "";
    if(name == null) name = url;
    var vor = "[url=" + url + "]";
    var nach = name + "[/url]";
    if(typeof document.selection != 'undefined') { // fr IE, auch Opera
	insertIE(textfeld);
    } else if (typeof textfeld.selectionStart != 'undefined') { // Geckos (FF)
        insertGecko(textfeld, vor, nach);
    }
}

// Im "textfeld" Portionen "vor" und "nach" einfgen (IE)
function insertIE(textfeld, vor, nach) {
    if(!rangeIE) rangeIE = document.selection.createRange();

    // nichts weiter tun, falls wir nicht im Textfeld sind
    if(rangeIE.parentElement().id != idTextfeld) {rangeIE = null; return;}

    var alterText = rangeIE.text;

    // Auswahl um BBC ergnzen
    rangeIE.text = vor + alterText + nach;

    // Cursor neu setzen (wie SelfHTML)
    if (alterText.length == 0) {
       rangeIE.move('character', -nach.length);
    } else {
       rangeIE.moveStart('character', rangeIE.text.length);
    }
     
     rangeIE.select();
     rangeIE = null;
}

// Im "textfeld" Portionen "vor" und "nach" einfgen (Geckos)
function insertGecko(textfeld, vor, nach) {
    von = textfeld.selectionStart;
    bis = textfeld.selectionEnd;

    // Text zerlegen
    anfang = textfeld.value.slice(0,   von);
    mitte  = textfeld.value.slice(von, bis);
    ende   = textfeld.value.slice(bis); // der Rest des Strings

    // BBC einfgen und ins Textfeld schreiben
    textfeld.value = anfang + vor + mitte + nach + ende;

    // Cursor neu setzen
    if(bis - von == 0) {
        textfeld.selectionStart = von + vor.length;
        textfeld.selectionEnd   = textfeld.selectionStart;
    } else {
        textfeld.selectionEnd   = bis + vor.length + nach.length;
        textfeld.selectionStart = textfeld.selectionEnd;
    }
}

  // Im IE die Textauswahl merken (onMouseDown im Farbwhler)
function getSelectionIE() {
    if (document.selection) {
        document.getElementById(idTextfeld).focus();
        rangeIE = document.selection.createRange();
    }
}